# -----------------------------------------------------------------------------
# Programm         : H i s t o r i e . p m
# -----------------------------------------------------------------------------
# Autor            : Christian Dhl
# Erstellt         : 10. Februar 2004
# Zuletzt gendert : 11. Februar 2004
# Aufgabe          : Klasse zur Verwaltung mehrerer Versionen von beliebigen
#                    Dingen, um Rckgngig und Wiederholen Funktionalitten
#                    verwenden zu knnen.
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Globale private Datei-Variablen:
# -----------------------------------------------------------------------------
my $Debug  = 2; # Debug level


# -----------------------------------------------------------------------------
# Klasse           : H i s t o r i e
# abgeleitet von   : Basis
# -----------------------------------------------------------------------------
# Autor            : Christian Dhl
# Beschreibung     : Eine Historien-Verwaltungs-Klasse.
# Attribute        : max         - maximale Anzahl gemerkter Dinge
#                    anzahl      - aktuelle Anzahl gemerkter Dinge
#                    _aktuell    - aktueller Index innerhalb der zu merkenden
#                                  Dinge.
#                    _hist       - Speicher fr Dinge.
# Klassen-Methoden : new         - Erstellt ein Objekt dieser Klasse.
# Objekt-Methoden  : max         - Getter / Setter
#                    anzahl      - Getter / Setter
#                    _aktuell    - Getter / Setter
#                    _hist       - Getter / Setter
# -----------------------------------------------------------------------------
# 0.0.1 - 10.02.2004 - CD - erstellt
# -----------------------------------------------------------------------------
package Graph::GED::Historie;

use strict;
use warnings;

use Data::Dumper;

use Data::Dumper;
use Graph::GED::Basis;

# -----------------------------------------------------------------------------
# Globale ffentliche Klassen-Variablen:
# -----------------------------------------------------------------------------
our @ISA   = ('Graph::GED::Basis');

sub new {
# -----------------------------------------------------------------------------
# Methode      : n e w
# Klasse       : Graph::GED::Historie
# -----------------------------------------------------------------------------
# Autor        : Christian Dhl
# Aufgabe      : Erzeugt eine neue Historie-Objekt.
# Parameter    : Klasse
# Rckgabewert : Das geblesste neue Objekt.
# -----------------------------------------------------------------------------
# 0.0.1 - 10.02.2004 - CD - erstellt
# -----------------------------------------------------------------------------

    my $self  = shift;
    my $class = (ref $self) || $self;

    #--------------------------------------------------------------------------
    # Ausgabe der Aufrufparameter:
    #--------------------------------------------------------------------------
    print "Graph::GED::Historie::new\n",
          "\tself       = '$self'\n",
          "\tclass      = '$class'\n",
          if $Debug > 1;


    $self = $class->SUPER::new();


    #--------------------------------------------------------------------------
    # Nun setzen wir noch ein paar Attribute:
    #--------------------------------------------------------------------------
    $self->max(20);
    $self->anzahl(0);
    $self->_aktuell(0);
    $self->_hist([]);


    #--------------------------------------------------------------------------
    # ... und geben das erzeugte Objekt zurck:
    #--------------------------------------------------------------------------
    return $self;

} # sub Ecke::new


# -----------------------------------------------------------------------------
# The getter/setter methods:
# -----------------------------------------------------------------------------
sub max      { return shift->_property('max',      @_) }
sub anzahl   { return shift->_property('anzahl',   @_) }
sub _aktuell { return shift->_property('_aktuell', @_) }
sub _hist    { return shift->_property('_hist',    @_) }


return 1;

__END__

=head1 NAME

Historie.pm - a module for take back and move ahead steps


=head1 COPYRIGHT

Copyright 2004 Christian Duehl. All rights reserved.

This library is free software. You can redistribute it and/or
modify it under the same terms as perl itself.

=cut

